init()
{
	// Conversion of stock server Cvars
	setCvar("g_allowvote", [[level.ex_drm]]("g_allowvote", 1, 0, 1, "int")); // level.allowvote in _serversettings.gsc
	setCvar("g_deadchat", [[level.ex_drm]]("g_deadchat", 1, 0, 1, "int")); // not script or menu related
	setCvar("g_debugdamage", [[level.ex_drm]]("g_debugdamage", 0, 0, 1, "int")); // cvar read by gametype scripts
	setCvar("g_oldvoting", [[level.ex_drm]]("g_oldvoting", 1, 0, 1, "int")); // not script or menu related
	setCvar("scr_friendlyfire", [[level.ex_drm]]("scr_friendlyfire", 0, 0, 3, "int")); // level.friendlyfire in _serversettings.gsc
	setCvar("scr_killcam", [[level.ex_drm]]("scr_killcam", 0, 0, 1, "int")); // level.killcam in _killcam.gsc
	setCvar("scr_spectateenemy", [[level.ex_drm]]("scr_spectateenemy", 0, 0, 1, "int")); // level.spectateenemy in _spectating.gsc
	setCvar("scr_spectatefree", [[level.ex_drm]]("scr_spectatefree", 1, 0, 1, "int")); // level.spectatefree in _spectating.gsc

	// hide objectives when in killcam mode
	level.ex_killcam_hideobj = [[level.ex_drm]]("ex_killcam_hideobj", 0, 0, 1, "int");

	// Draws a team icon over teammates (_friendicons.gsc)
	level.drawfriend = [[level.ex_drm]]("scr_drawfriend", 1, 0, 1, "int");
	setCvar("scr_drawfriend", level.drawfriend);

	// Force respawning (gametype scripts)
	level.forcerespawn = [[level.ex_drm]]("scr_forcerespawn", 0, 0, 1,"int");
	setCvar("scr_forcerespawn", level.forcerespawn);

	// If death music is on, this overrides forcespawn
	if(level.forcerespawn && level.ex_deathmusic)
	{
		setCvar("scr_forcerespawn", "0");
		level.forcerespawn = false;
	}

	// Respawn delay
	level.respawndelay = [[level.ex_drm]]("scr_respawndelay", 0, 0, 60, "int");
	setCvar("scr_respawndelay", level.respawndelay);

	// Auto Team Balancing (_teams.gsc)
	level.teambalance = [[level.ex_drm]]("scr_teambalance", 1, 0, 1, "int");
	setCvar("scr_teambalance", level.teambalance);

	level.ex_teambalance_delay = [[level.ex_drm]]("ex_teambalance_delay", 60, 0, 300, "int");

	// Voiceover on flag events
	level.ex_flag_voiceover = [[level.ex_drm]]("ex_flag_voiceover", 15, 0, 15, "int");

	// flag drop at will
	level.ex_flag_drop = [[level.ex_drm]]("ex_flag_drop", 0, 0, 1, "int");

	// Time limit per map
	level.timelimit = [[level.ex_drm]]("scr_" + level.ex_currentgt + "_timelimit", 30, 0, 1440, "float");
	setCvar("scr_" + level.ex_currentgt + "_timelimit", level.timelimit);

	// Score limit per map
	level.scorelimit = [[level.ex_drm]]("scr_" + level.ex_currentgt + "_scorelimit", 1, 0, 9999, "int");
	setCvar("scr_" + level.ex_currentgt + "_scorelimit", level.scorelimit);

	// dom, esd, lts, ons, rbcnq, rbctf, sd
	if(level.ex_roundbased)
	{
		// round limit
		level.roundlimit = [[level.ex_drm]]("scr_" + level.ex_currentgt + "_roundlimit", 5, 0, 99, "int");
		setCvar("scr_" + level.ex_currentgt + "_roundlimit", level.roundlimit);

		// round length
		level.roundlength = [[level.ex_drm]]("scr_" + level.ex_currentgt + "_roundlength", 5, 1, 1440, "float");
		setCvar("scr_" + level.ex_currentgt + "_roundlength", level.roundlength);

		// bomb timer?
		if(level.ex_currentgt == "sd" || level.ex_currentgt == "esd")
		{
			level.bombtimer = [[level.ex_drm]]("scr_" + level.ex_currentgt + "_bombtimer", 60, 30, 120, "int");
			level.planttime = [[level.ex_drm]]("scr_" + level.ex_currentgt + "_planttime", 5, 1, 60, "int");
			level.defusetime = [[level.ex_drm]]("scr_" + level.ex_currentgt + "_defusetime", 10, 1, 60, "int");
		}
	}
}

createClock(clocktype, timer)
{
	if(!isDefined(clocktype)) clocktype = 1; // 1 = level.clock, 2 = level.roundclock
	if(!isDefined(timer)) timer = 0; // time for countdown

	clockx = 8;
	clocky = 2;

	if(clocktype == 1)
	{
		if(isDefined(level.roundclock))
		{
			level.roundclock.x = 100;
			level.roundclock.y = 2;
		}

		if(!isDefined(level.clock))
		{
			level.clock = newHudElem();
			level.clock.archived = true;
			level.clock.sort = 0;
			level.clock.horzAlign = "fullscreen";
			level.clock.vertAlign = "fullscreen";
			level.clock.alignX = "left";
			level.clock.alignY = "top";
			level.clock.x = clockx;
			level.clock.y = clocky;
			level.clock.font = "default";
			level.clock.color = (0.705, 0.705, 0.392);
			level.clock.fontscale = 2;
		}
		if(timer) level.clock setTimer(timer);
	}

	if(clocktype == 2)
	{
		if(isDefined(level.clock))
		{
			clockx = 100;
			clocky = 2;
		}

		if(!isDefined(level.roundclock))
		{
			level.roundclock = newHudElem();
			level.roundclock.archived = true;
			level.roundclock.sort = 0;
			level.roundclock.horzAlign = "left";
			level.roundclock.vertAlign = "top";
			level.roundclock.alignX = "left";
			level.roundclock.alignY = "top";
			level.roundclock.x = clockx;
			level.roundclock.y = clocky;
			level.roundclock.font = "default";
			level.roundclock.color = (0.98, 0.827, 0.58);
			level.roundclock.fontscale = 2;
		}
		if(timer) level.roundclock setTimer(timer);
	}
}
