/*------------------------------------------------------------------------------
Based on Weapons on Back code from R&R Projects
------------------------------------------------------------------------------*/

init()
{
	if(!level.ex_weaponsonback || (level.ex_weaponsonback == 1 && !level.ex_wepo_secondary) ) return;
	level thread onPlayerConnect();
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connected", player);
		player thread onPlayerSpawned();
	}
}

onPlayerSpawned()
{
	self endon("disconnect");

	for(;;)
	{
		self waittill("spawned_player");
		if(level.ex_wepo_secondary) self thread wob_twoslotmonitor();
			else wob_oneslotmonitor();
	}
}

wob_twoslotmonitor()
{
	self endon("ex_gameover");
	self endon("disconnect");
	self endon("ex_dead");

	self.weapononback = undefined;
	wobactiveslot = "none";

	for(;;)
	{
		wait( [[level.ex_fpstime]](0.5) );

		attach_enabled = true;
		if(level.ex_currentgt == "lib" && isDefined(self.in_jail) && self.in_jail) attach_enabled = false;

		currentweapon = self getcurrentweapon();

		if(isValidWeapon(currentweapon))
		{
			weapon1 = self getweaponslotweapon("primary");
			weapon2 = self getweaponslotweapon("primaryb");

			// When carrying a flamethrower (any slot), the tank is on the back. Do not add another weapon
			if(isFlamethrower(weapon1) || isFlamethrower(weapon2)) continue;

			if(currentweapon == weapon1) currentslot = "primary";
				else currentslot = "primaryb";

			if(currentslot != wobactiveslot)
			{
				wobactiveslot = currentslot;

				// Detach current weapon on back
				if(isDefined(self.weapononback))
				{
					self detach("xmodel/" + self.weapononback, "");
					self.weapononback = undefined;
				}

				wait( [[level.ex_fpstime]](0.05) );

				// If primary is active, put secondary weapon on back
				if(attach_enabled)
				{
					if(wobactiveslot == "primary")
					{
						if(isValidWeapon(weapon2) && isValidWeaponOnBack(weapon2))
						{
							self.weapononback = weapon2;
							self attach("xmodel/" + self.weapononback, "");
						}
					}
					// If secondary is active, put primary weapon on back
					else //if(wobactiveslot == "primaryb")
					{
						if(isValidWeapon(weapon1) && isValidWeaponOnBack(weapon1))
						{
							self.weapononback = weapon1;
							self attach("xmodel/" + self.weapononback, "");
						}
					}
				}
			}
		}
	}
}

wob_oneslotmonitor()
{
	self endon("ex_gameover");
	self endon("disconnect");
	self endon("ex_dead");

	self.weapononback = undefined;
	wobactiveweapon = "none";

	for(;;)
	{
		wait( [[level.ex_fpstime]](0.5) );

		attach_enabled = true;
		if(level.ex_currentgt == "lib" && isDefined(self.in_jail) && self.in_jail) attach_enabled = false;

		currentweapon = self getcurrentweapon();

		if(isValidWeapon(currentweapon) && currentweapon != wobactiveweapon)
		{
			// When carrying a flamethrower, the tank is on the back. Do not add another weapon
			if(isFlamethrower(currentweapon)) continue;

			wobactiveweapon = currentweapon;

			// Detach current weapon on back
			if(isDefined(self.weapononback))
			{
				self detach("xmodel/" + self.weapononback, "");
				self.weapononback = undefined;
			}

			wait( [[level.ex_fpstime]](0.05) );

			// Put current weapon on back
			if(attach_enabled)
			{
				if(isValidWeaponOnBack(wobactiveweapon))
				{
					self.weapononback = wobactiveweapon;
					self attach("xmodel/" + self.weapononback, "");
				}
			}
		}
	}
}

isValidWeapon(weapon)
{
	if(!isDefined(weapon)) return false;

	switch(weapon)
	{
		case "none":
		case "ignore":
		case "sprint_mp":
		case "knife_mp":
		case "colt_mp":
		case "webley_mp":
		case "tt30_mp":
		case "luger_mp":
		case "colt_vip_mp":
		case "webley_vip_mp":
		case "tt30_vip_mp":
		case "luger_vip_mp":
		case "binoculars_mp": return false;
	}

	return true;
}

isFlamethrower(weapon)
{
	switch(weapon)
	{
		case "flamethrower_axis":
		case "flamethrower_allies": return true;
	}

	return false;
}

isValidWeaponOnBack(weapon)
{
	if(!isDefined(weapon)) return false;

	switch(weapon)
	{
		case "dummy1_mp":
		case "dummy2_mp":
		case "dummy3_mp":
		case "dummy4_mp":
		case "springfield_2_mp":
		case "enfield_scope_2_mp":
		case "mosin_nagant_sniper_2_mp":
		case "kar98k_sniper_2_mp":
		case "g43_sniper_2":
		case "gunship_25mm_mp":
		case "gunship_40mm_mp":
		case "gunship_105mm_mp":
		case "gunship_nuke_mp": return false;
	}

	return true;
}
