init()
{
	precacheShader("overlay_low_health");
	if(level.ex_healthsystem == 2) return;
	level thread onPlayerConnect();
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connecting", player);
		player thread onPlayerSpawned();
		player thread onPlayerKilled();
		player thread onJoinedTeam();
		player thread onJoinedSpectators();
		player thread onPlayerDisconnect();
	}
}

onJoinedTeam()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("joined_team");
		self notify("end_healthregen");
	}
}

onJoinedSpectators()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("joined_spectators");
		self notify("end_healthregen");
	}
}

onPlayerSpawned()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("spawned_player");
		self thread playerHealthRegen();
	}
}

onPlayerKilled()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("killed_player");
		self notify("end_healthregen");
	}
}

onPlayerDisconnect()
{
	self waittill("disconnect");
	self notify("end_healthregen");
}

playerHealthRegen()
{
	self endon("end_healthregen");

	player = self;
	maxhealth = self.health;
	oldhealth = maxhealth;
	hurtTime = 0;

	regenRate = (20 - level.ex_healthregen_rate) + 1;
	regenTick = regenRate;

	if(level.ex_healthregen_heavybreathing) thread playerBreathingSound(maxhealth * (level.ex_healthregen_heavybreathing_cutoff / 100));

	for(;;)
	{
		wait( [[level.ex_fpstime]](0.05) );
		if(player.health == maxhealth) continue;

		if(player.health <= 0 || maxhealth <= 0) return;

		if(player.health >= oldhealth)
		{
			if(gettime() - hurtTime < level.ex_healthregen_delay) continue;

			regenTick--;
			if(!regenTick)
			{
				oldhealth = player.health;
				player.health++;
				regenTick = regenRate;
			}

			continue;
		}

		oldhealth = player.health;
		hurtTime = gettime();
	}
}

playerBreathingSound(healthcap)
{
	self endon("end_healthregen");
	
	wait( [[level.ex_fpstime]](2) );
	player = self;
	better = false;

	for(;;)
	{
		wait( [[level.ex_fpstime]](0.2) );
		if(player.health <= 0) return;

		if(player.health >= healthcap)
		{
			if(!better)
			{
				player playLocalSound("breathing_better");
				better = true;
			}
		}
		else
		{
			better = false;
			player playLocalSound("breathing_hurt");
		}

		wait( [[level.ex_fpstime]](0.784) );
		wait( [[level.ex_fpstime]](0.1 + randomfloat (0.8)) );
	}
}
